<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
// +----------------------------------------------------------------------+
// | PHP version 5                                                        |
// +----------------------------------------------------------------------+
// | Copyright 2005-2006 the Seasar Foundation and the Others.            |
// +----------------------------------------------------------------------+
// | Licensed under the Apache License, Version 2.0 (the "License");      |
// | you may not use this file except in compliance with the License.     |
// | You may obtain a copy of the License at                              |
// |                                                                      |
// |     http://www.apache.org/licenses/LICENSE-2.0                       |
// |                                                                      |
// | Unless required by applicable law or agreed to in writing, software  |
// | distributed under the License is distributed on an "AS IS" BASIS,    |
// | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,                        |
// | either express or implied. See the License for the specific language |
// | governing permissions and limitations under the License.             |
// +----------------------------------------------------------------------+
// | Authors: klove                                                       |
// +----------------------------------------------------------------------+
//
// $Id: S2Container_ExpressionConstructorAssembler.class.php 255 2006-05-23 14:51:12Z klove $
/**
 * @package org.seasar.framework.container.assembler
 * @author klove
 */
class S2Container_ExpressionConstructorAssembler
    extends S2Container_AbstractConstructorAssembler
{
    /**
     * @param S2Container_ComponentDef
     */
    public function __construct(S2Container_ComponentDef $componentDef)
    {
        parent::__construct($componentDef);
    }

    /**
     * 
     */
    public function assemble()
    {
        $cd = $this->getComponentDef();
        $container = $cd->getContainer();
        $expression = $cd->getExpression();
        $componentClass = $cd->getComponentClass();
        $component = null;

        if ($container->hasComponentDef($expression)) {
            $component = $container->getComponent($expression);
        } else {
            $exp = S2Container_EvalUtil::getExpression($expression);
            if(defined('S2CONTAINER_PHP5_DEBUG_EVAL') and S2CONTAINER_PHP5_DEBUG_EVAL){
                S2Container_S2Logger::getLogger(__CLASS__)->
                    debug("[ $exp ]",__METHOD__);
            }
            $component = eval($exp);
        }
        
        if (!is_object($component)) {
            throw new S2Container_S2RuntimeException('ESSR0017',
                               array("eval() result isnt an Object. "));
        }
        if ($componentClass instanceof ReflectionClass) {
             $refExpClass = new ReflectionClass($component);
               if (!$refExpClass->isSubclassOf($componentClass)) {
                  throw new S2Container_ClassUnmatchRuntimeException($componentClass,
                                                                     $refExpClass);    
               }
           }
        $cd->setComponentClass(new ReflectionClass($component));
        return $component;        
    }
}
?>
