<?php
/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */
// +----------------------------------------------------------------------+
// | PHP version 5                                                        |
// +----------------------------------------------------------------------+
// | Copyright 2005-2006 the Seasar Foundation and the Others.            |
// +----------------------------------------------------------------------+
// | Licensed under the Apache License, Version 2.0 (the "License");      |
// | you may not use this file except in compliance with the License.     |
// | You may obtain a copy of the License at                              |
// |                                                                      |
// |     http://www.apache.org/licenses/LICENSE-2.0                       |
// |                                                                      |
// | Unless required by applicable law or agreed to in writing, software  |
// | distributed under the License is distributed on an "AS IS" BASIS,    |
// | WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,                        |
// | either express or implied. See the License for the specific language |
// | governing permissions and limitations under the License.             |
// +----------------------------------------------------------------------+
// | Authors: klove, KIYO-SHIT                                            |
// +----------------------------------------------------------------------+
//
// $Id:$
/**
 * @author klove, KIYO-SHIT
 */
class S2JavelinTraceInterceptor extends S2Container_AbstractInterceptor
{
    /**
     * ᥽åɸƤӽФJavlinƬ˽Ϥ뼱̻ҡ
     */
    const KEY_CALL = "Call  ";

    /**
     * ᥽åJavlinƬ˽Ϥ뼱̻ҡ
     */
    const KEY_RETURN = "Return";

    /**
     * 㳰throwJavlinƬ˽Ϥ뼱̻ҡ
     */
    const KEY_THROW = "Throw ";

    /**
     * 㳰catchJavlinƬ˽Ϥ뼱̻ҡ
     */
    const KEY_CATCH = "Catch ";

    
    public static $CALLER_STACKTRACE_INDEX = 1;

    /**
     * ζڤʸ
     */
    const DELIM = ",";

    /**
     * åɾζڤʸ
     */
    const THREAD_DELIM = "@";

    /**
     * ϤΥեޥåȡ
     * const TIME_FORMAT_STR = "yyyy/MM/dd HH:mm:ss.SSS";
     */

    /**
     * ᥽åɤθƤӽФ֥Ȥɽʸ
     */
    private static $callerLog_ = "<unknown>,<unknown>,0";

    /**
     * Ϥ뤫ɤ
     * argsץѥƥͤåȤ롣
     */
    private $isLogArgs_ = true;

    /**
     * ͤϤ뤫ɤ
     * returnץѥƥͤåȤ롣
     */
    private $isLogReturn_ = true;

    /**
     * åȥ졼Ϥ뤫ɤ
     * stackTraceץѥƥͤåȤ롣
     */
    private $isLogStackTrace_ = false;

    /**
     * åȥ졼Ϥ뤫ɤ
     * stackTraceץѥƥͤåȤ롣
     */
    private $logFile_ = "";

    /**
     * 㳰ȯϿơ֥롣
     * ˥åɤμ̻ҡͤ㳰֥Ȥ롣
     * 㳰ȯ餳Υޥåפˤ㳰Ͽ
     * å줿Ǻ롣
     */
    static private $exceptionMap_ = array();
    
    /**
     * JavelinѤinvoke᥽åɡ
     * 
     * ºݤΥ᥽åɸƤӽФ¹Ԥǡ
     * ƤӽФֵѤξܺ٥JavelinǽϤ롣
     * 
     * ¹Ի㳰ȯϡξܺ٤Ϥ롣
     * 
     * @param invocation
     *            󥿡ץˤäƼ줿ƤӽФ᥽åɤξ
     * @return invocation¹ԤȤ
     * @throws Throwable invocation¹ԤȤȯ㳰
     */
    public function invoke(S2Container_MethodInvocation $invocation)
    {
        $methodCallBuff = "";

        // ƤӽФ
        $calleeMethodName = $invocation->getMethod()->getName();
        $calleeClassName = $this->getTargetClass($invocation)->getName();
        $objectID = $invocation->getThis();
        $modifiers = implode(' ', Reflection::getModifierNames(
                                  $invocation->getMethod()->getModifiers()));
        // ƤӽФ
        $currentCallerLog = self::$callerLog_;

        $threadName = "php";
        $threadClassName = "proccess";
        $threadID = $this->getId();
        $threadInfo = $threadName      . self::THREAD_DELIM .
                      $threadClassName . self::THREAD_DELIM .
                      $threadID;

        // ᥽åɸƤӽФʬ
        $methodCallBuff =  $calleeMethodName . self::DELIM .
                           $calleeClassName  . self::DELIM .
                           $objectID;

        // ƤӽФΥ򡢼ϻθƤӽФȤƻѤ뤿¸롣
        self::$callerLog_ = $methodCallBuff;

        $methodCallBuff .= self::DELIM .
                           $currentCallerLog . self::DELIM .
                           $modifiers        . self::DELIM .
                           $threadInfo       . PHP_EOL;

        // Call ܺ٥
        $callDetailBuff = $this->createCallDetail($methodCallBuff,$invocation);

        // Call ϡ
        $this->logOut($callDetailBuff);

        //ºݤΥ᥽åɸƤӽФ¹Ԥ롣
        //¹㳰ȯ顢ξܺ٥Ϥ롣
        $ret = null;
        try
        {
            // ᥽åɸƤӽФ
            $ret = $invocation->proceed();
        }
        catch (Exception $cause)
        {
            // Throwܺ٥
            $throwBuff = $this->createThrowCatchDetail(
                                self::KEY_THROW, 
                                $calleeMethodName,
                                $calleeClassName,
                                $objectID,
                                $threadInfo, 
                                $cause);

            // Throw ϡ
            $this->logOut($throwBuff);

            //㳰ȯϿ롣
            self::$exceptionMap_[$threadInfo] = $cause;
            
            //㳰򥹥λ롣
            throw $cause;
        }
        
        //Υåɤǡľ㳰ȯƤǧ롣
        //ȯƤƤˤɤ夤ΤǤСλ㳰
        //catch줿ȤȤˤʤΤǡCatchϤ롣
        $isExceptionThrowd = array_key_exists($threadInfo,self::$exceptionMap_);
        if($isExceptionThrowd == true) 
        {
            //ȯƤ㳰֥ȤޥåפФʤĺ
            $exp = self::$exceptionMap_[$threadInfo];
            unset(self::$exceptionMap_[$threadInfo]);
            
            // Catchܺ٥
            $throwBuff = $this->createThrowCatchDetail(
                                self::KEY_CATCH,
                                $calleeMethodName,
                                $calleeClassName,
                                $objectID,
                                $threadInfo,
                                $exp);

            // Catch ϡ
            $this->logOut($throwBuff);
        }

        // Returnܺ٥
        $returnDetailBuff = $this->createReturnDetail($methodCallBuff,$ret);

        // Returnϡ
        $this->logOut($returnDetailBuff);

        self::$callerLog_ = $currentCallerLog;

        //invocation¹Ԥݤ֤ͤ
        return $ret;
    }

    /**
     * ᥽åɸƤӽФʼ̻Callˤξܺ٤ʥ롣
     * 
     * @param methodCallBuff ᥽åɸƤӽФʸ
     * @param invocation ᥽åɸƤӽФξ
     * @return ᥽åɸƤӽФξܺ٤ʥ
     */
    private function createCallDetail($methodCallBuff,
                                      $invocation)
    {
        $timeStr = $this->getTime();
        $callDetailBuff = self::KEY_CALL . self::DELIM .
                          $timeStr       .  self::DELIM .
                          $methodCallBuff;

        // Υ롣
        if ($this->isLogArgs_ == true)
        {
            $callDetailBuff .= "<<javelin.Args_START>>" . PHP_EOL;
            $args = $invocation->getArguments();
            $c = count($args);
            for($i = 0; $i < $c; $i++){
                $callDetailBuff .= "    args[$i] = " . $this->mixToString($args[$i]) . PHP_EOL;
            }
            $callDetailBuff .= "<<javelin.Args_END>>" . PHP_EOL;
        }

        // åȥ졼Υ롣
        if ($this->isLogStackTrace_ == true)
        {
            $callDetailBuff .= "<<javelin.StackTrace_START>>" . PHP_EOL;
            $stackTraceElements = null;
            try{
                throw new Exception();    
            }
            catch(Exception $e){
                $stackTraceElements = preg_split("/#\d+\s/",$e->getTraceAsString());
            }
            $c = count($stackTraceElements);
            for ($index = self::$CALLER_STACKTRACE_INDEX; $index < $c; $index++)
            {
                $callDetailBuff .= "    at " . $stackTraceElements[$index];
            }

            $callDetailBuff .= PHP_EOL . "<<javelin.StackTrace_END>>" . PHP_EOL;
        }

        if ($invocation->getThis() instanceof Exception)
        {
            $callDetailBuff .= "<<javelin.Exception>>" . PHP_EOL;
        }
        return $callDetailBuff;
    }

    /**
     * ᥽åɤʼ̻Returnˤξܺ٤ʥ롣
     * 
     * @param methodCallBuff ᥽åɸƤӽФʸ
     * @param ret ᥽åɤ
     * @return ᥽åɤξܺ٤ʥ
     */
    private function createReturnDetail($methodCallBuff,$ret)
    {
        $returnTimeStr = $this->getTime();
        $returnDetailBuff = self::KEY_RETURN . self::DELIM .
                            $returnTimeStr . self::DELIM .
                            $methodCallBuff;

        // ͤΥ롣
        if ($this->isLogReturn_)
        {
            $returnDetailBuff .= "<<javelin.Return_START>>"        . PHP_EOL
                               . "    " . $this->mixToString($ret) . PHP_EOL
                               . "<<javelin.Return_END>>"          . PHP_EOL;
        }
        return $returnDetailBuff;
    }

    /**
     * 㳰ȯʼ̻Throwˡޤ㳰åCatchˤξܺ٥롣
     * 
     * @param id ̻ҡThrowޤCatch
     * @param calleeMethodName ƤӽФ᥽å̾
     * @param calleeClassName ƤӽФ襯饹̾
     * @param objectID ƤӽФ襯饹Υ֥ID
     * @param threadInfo åɾ
     * @param cause ȯ㳰
     * @return 㳰ȯξܺ٤ʥ
     */
    private function createThrowCatchDetail(
                     $id,
                     $calleeMethodName,
                     $calleeClassName,
                     $objectID,
                     $threadInfo,
                     $cause)
    {
        $throwTimeStr = $this->getTime();
        $throwableID = (string)$cause;
        $throwBuff = $id . self::DELIM .
                     $throwTimeStr     . self::DELIM .
                     get_class($cause) . self::DELIM .
                     $throwableID      . self::DELIM .
                     $calleeMethodName . self::DELIM .
                     $calleeClassName  . self::DELIM .
                     $objectID         . self::DELIM .
                     $threadInfo       . PHP_EOL;
        return $throwBuff;
    }

    /**
     * ƤϤ뤫ɤꤹ롣
     * @param isLogArgs Ϥʤtrue
     */
    public function setLogArgs($isLogArgs)
    {
        $this->isLogArgs_ = $isLogArgs;
    }

    /**
     * ͤƤϤ뤫ɤꤹ롣
     * @param isLogReturn ͤϤʤtrue
     */
    public function setLogReturn($isLogReturn)
    {
        $this->isLogReturn_ = $isLogReturn;
    }

    /**
     * ᥽åɸƤӽФޤǤΥåȥ졼Ϥ뤫ꤹ롣
     * @param isLogStackTrace åȥ졼Ϥʤtrue
     */
    public function setLogStackTrace($isLogStackTrace)
    {
        $this->isLogStackTrace_ = $isLogStackTrace;
    }

    public function setLogFile($logFile)
    {
        if(!is_writable(dirname($logFile))){
            throw new Exception("can not write log file. [ $logFile ]");
        }
        $this->logFile_ = $logFile;
    }
    
    private function logOut($msg)
    {
        if(S2Container_S2LogFactory::$LOGGER == S2Container_S2LogFactory::LOG4PHP){
            S2Container_S2Logger::getLogger(__CLASS__)->debug($msg); 	
        } else {
            if(!file_put_contents($this->logFile_, $msg, FILE_APPEND | LOCK_EX)){
                throw new Exception("can not write file. [{$this->logFile_}]");
            }
        }
    }

    private function getTime()
    {
        list($usec, $sec) = explode(" ", microtime());
        return date('Y/m/d H:i:s',$sec) . substr($usec,1,4);
    }

    private function getId()
    {
        return self::$ID;
    }
    
    private static $ID = null;
    public function __construct(){
        if (self::$ID == null){
            self::$ID = uniqid();
        }
    }

    private function mixToString($val) {
        if (is_array($val)) {
            $c = count($val);
            return "array($c)";
        } else if (is_object($val)){
            $name = get_class($val);
            return "object<$name>";
        } else if (is_bool($val)){
            if ($val) {
                return 'true';
            } else {
                return 'false';
            }
        } else if (is_null($val)){
            return 'null';
        } else {
            return $val;   
        }
    }

}
?>
